def load_data(filename):
    f = open(filename)
    seqs={}
    pfams={}

    for row in f:
        data = row.split()
        if not seqs.has_key(data[0]):
            seqs[data[0]]=[]
        seqs[data[0]].append(data[3])
        pfams[data[3]]=data[-1]
    
    f.close()
    return seqs,pfams


def counts_per_entry(seqs):
    counts={}

    for (prot,pfams) in seqs.items():
        for pfam in pfams:
            if not counts.has_key(pfam):
                counts[pfam]=1
            else:
                counts[pfam]+=1

    return counts

def counts_per_sequence(seqs):
    counts={}

    for (prot,pfams) in seqs.items():
        pfams_unique={}
        for pfam in pfams:
            pfams_unique[pfam]=1            
        for pfam in pfams_unique.keys():
            if not counts.has_key(pfam):
                counts[pfam]=1
            else:
                counts[pfam]+=1

    return counts


def print_stats(totcounts,uniquecounts,pfams):
    
    sortedcounts = [(v,k) for (k,v) in totcounts.items()]
    sortedcounts.sort(reverse=True)

    print "Pfam Number\tPfam Name\tTotCount\tProtCount\n"
    print "\n".join(["%s\t%s\t%d\t%d" % (prot,pfams[prot],count,uniquecounts[prot]) for (count,prot) in sortedcounts])
        

def pfam_statistics(pfamfile):
    seqs,pfams = load_data(pfamfile)
    totcounts = counts_per_entry(seqs)
    uniquecounts = counts_per_sequence(seqs)
    print_stats(totcounts,uniquecounts,pfams)


pfamfile=raw_input("Inserire nome file: ")
pfam_statistics(pfamfile)
